=== debian/changelog ===
pgrouting (2.3.2+ds-2) unstable; urgency=medium

  * Team upload.
  * Add postgis to build dependencies to limit archs to where it's available.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 10 Jan 2017 19:34:33 +0100

pgrouting (2.3.2+ds-1) unstable; urgency=medium

  * Team upload.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 09 Jan 2017 19:20:33 +0100

pgrouting (2.3.2+ds-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
  * Update copyright file for other CC-BY-SA-3.0 documentation.
  * Split SQL scripts off into separate arch:all package.
  * Repack upstream tarball to exclude .gitattributes file,
    causes changes to the upstream source with git-buildpackage.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 07 Jan 2017 22:25:55 +0100

pgrouting (2.3.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 20 Nov 2016 22:11:08 +0100

pgrouting (2.3.0-2) unstable; urgency=medium

  * Team upload.
  * Change pgversions from 'all' to '9.2+' to match postgis.
  * Add autopkgtest installability test.
    (closes: #839127)

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 02 Oct 2016 10:20:16 +0200
