=== debian/control ===
Source: pgrouting
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Michael Fladischer <FladischerMichael@fladi.at>
Section: misc
Priority: optional
Build-Depends: cmake,
               debhelper (>= 9),
               libboost-graph-dev,
               libcgal-dev,
               libjs-mathjax,
               postgis,
               postgresql-server-dev-all,
               python-sphinx (>= 1.0.7+dfsg)
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-grass/pgrouting.git
Vcs-Git: https://anonscm.debian.org/git/pkg-grass/pgrouting.git
Homepage: http://www.pgrouting.org

Package: postgresql-9.6-pgrouting
Architecture: any
Depends: postgresql-9.6-pgrouting-scripts (>= ${source:Version}),
         postgresql-9.6,
         postgresql-9.6-postgis-2.3,
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: postgresql-9.6-pgrouting-doc
Description: Routing functionality support for PostgreSQL/PostGIS
 pgRouting extends the PostGIS/PostgreSQL geospatial database to provide
 geospatial routing and other network analysis functionality.
 .
 This package supports PostgreSQL 9.6.

Package: postgresql-9.6-pgrouting-scripts
Architecture: all
Depends: ${misc:Depends}
Breaks: postgresql-9.6-pgrouting (<< 2.3.2)
Replaces: postgresql-9.6-pgrouting (<< 2.3.2)
Description: Routing functionality support for PostgreSQL/PostGIS - scripts
 pgRouting extends the PostGIS/PostgreSQL geospatial database to provide
 geospatial routing and other network analysis functionality.
 .
 This package contains SQL scripts to upgrade from earlier pgRouting
 versions for PostgreSQL 9.6.

Package: postgresql-9.6-pgrouting-doc
Architecture: all
Section: doc
Depends: libjs-mathjax,
         ${misc:Depends},
         ${sphinxdoc:Depends}
Description: Routing functionality support for PostgreSQL/PostGIS (Documentation)
 pgRouting extends the PostGIS/PostgreSQL geospatial database to provide
 geospatial routing and other network analysis functionality.
 .
 This package contains the documentation.
