=== src/costMatrix/sql/CMakeLists.txt ===
# Append in local scope
LIST(APPEND PACKAGE_SQL_FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/withPointsCostMatrix.sql
    ${CMAKE_CURRENT_SOURCE_DIR}/dijkstraCostMatrix.sql
    ${CMAKE_CURRENT_SOURCE_DIR}/astarCostMatrix.sql

    )

# set in parent scope
SET(PACKAGE_SQL_FILES "${PACKAGE_SQL_FILES}" PARENT_SCOPE)
