=== debian/changelog ===
pgrouting (2.4.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Bump Standards-Version to 4.0.0, no changes.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 16 Aug 2017 18:16:57 +0200

pgrouting (2.4.1-1) unstable; urgency=medium

  * Team upload.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 18 Jun 2017 18:03:18 +0200

pgrouting (2.4.1-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 24 Mar 2017 16:58:30 +0100

pgrouting (2.4.0-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
  * Update copyright file, changes:
    - Update copyright years for copyright holders
    - Update file lists for upstream changes
  * Update release_notes.rst path for dh_installchangelogs.
  * Refresh patches.
  * Update HTML files list in doc-base registration.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 21 Mar 2017 07:49:55 +0100
