=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
                postgis,
                postgresql-server-dev-all,
                python-sphinx (>= 1.0.7+dfsg)
-Standards-Version: 3.9.8
+Standards-Version: 4.0.0
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-grass/pgrouting.git
 Vcs-Git: https://anonscm.debian.org/git/pkg-grass/pgrouting.git
 Homepage: http://www.pgrouting.org
