=== debian/rules ===
--- 
+++ 
@@ -61,7 +61,7 @@
 	dh_install --list-missing
 
 override_dh_installchangelogs:
-	dh_installchangelogs doc/src/changelog/release_notes.rst
+	dh_installchangelogs doc/src/release_notes.rst
 
 override_dh_makeshlibs:
 	dh_makeshlibs -Xusr/lib/postgresql
